#ifndef OUTPUT_H
#define OUTPUT_H

#include <stdio.h>
#include <ogg/ogg.h>

typedef struct {
  FILE *file;
  char *filename;

  int id; /* unique number for each output_t */
  int count; /* the number of streams writing to the file */
} output_t;

typedef struct {
  output_t *outputs;
  int outputs_size;
  int outputs_used;
  int idcount;

  char *dirname;
  char *basename;
} output_ctrl_t;


int       output_ctrl_init(output_ctrl_t *oc,
			   char *dirname, char *filename);
int       output_ctrl_free(output_ctrl_t *oc);
output_t *output_ctrl_output_new(output_ctrl_t *oc, int chain_c, int group_c);
int       output_ctrl_output_free(output_ctrl_t *oc, int id);

int       output_page_write(output_t *op, ogg_page *og);

#endif /* OUTPUT_H */
