#ifndef STREAM_H
#define STREAM_H

#include <ogg/ogg.h>
#include "output.h"

#define STREAM_TYPE_UNKNOWN   0x00
#define STREAM_TYPE_VORBIS    0x01
#define STREAM_TYPE_THEORA    0x02
#define STREAM_TYPE_SPEEX     0x03
#define STREAM_TYPE_FLAC      0x04

typedef struct {
  int    serial;
  int    type;

  output_t *op; /* the id of the output */
} stream_t;

typedef struct {
  stream_t *streams;
  int       streams_size; /* num of alloced stream_t's */
  int       streams_used; /* num of stream_t's in use */
} stream_ctrl_t;

int       stream_ctrl_init(stream_ctrl_t *sc);
int       stream_ctrl_free(stream_ctrl_t *sc);
stream_t *stream_ctrl_stream_new(stream_ctrl_t *sc, ogg_page *og);
stream_t *stream_ctrl_stream_get(stream_ctrl_t *sc, int serial);
int       stream_ctrl_stream_free(stream_ctrl_t *sc, int serial);

const char* stream_type_name(stream_t *stream);

#endif /* STREAM_H */
